%global sqlcipher_ver 1.4.4

Summary: An efficient, complete, easy-to-use mobile database framework used in the WeChat application.
Name: wcdb
Version: 2.1.6
Release: 1%{?dist}
License: BSD 3-Clause
URL: https://github.com/Tencent/wcdb
Source0: https://github.com/Tencent/wcdb/archive/refs/tags/v%{version}.zip
Source1: https://github.com/Tencent/sqlcipher/archive/refs/tags/v%{sqlcipher_ver}.zip


Patch5000: fix-compile-error-in-Linux.patch

BuildRequires: gcc, cmake, g++, openssl, zstd

%description
WCDB is an efficient, complete, easy-to-use 
mobile database framework used in the WeChat application. 
It's based on SQLite and SQLCipher, 
and supports five languages: C++, Java, Kotlin, Swift and 
Objective-C.

%prep
%autosetup -p1
unzip %{SOURCE1}
rm -rf sqlcipher
mv sqlcipher-%{sqlcipher_ver} sqlcipher
# make sure the source folder exists
mkdir -p src/build
cd src/build
# supplementary necessary documents
cp ../../sqlcipher/src/parse.y .
cp ../../sqlcipher/parse.c .

%build
cd src/build
# WCDB_ZSTD=OFF means does not compile ZSTD from WCDB, uses zstd provided by the OC distribution.
cmake -DCMAKE_SKIP_RPATH=ON -DWCDB_ZSTD=OFF ..
cmake --build . -j%{?_smp_build_ncpus}

%install
# Creating a Destination Directory
install -d %{buildroot}%{_includedir}/WCDB %{buildroot}%{_libdir}
# Installing header files
install -D src/build/export_headers/WCDB/* %{buildroot}%{_includedir}/WCDB/
# Remove executable permissions
find %{buildroot}%{_includedir}/WCDB/ -type f -exec chmod -x {} \;
# Installing library files
install -D src/build/libWCDB.so %{buildroot}%{_libdir}/libWCDB.so

%files
%{_includedir}/WCDB/
%{_libdir}/libWCDB.so

%changelog
* Tue Aug 6 2024 ConanYao <JaneConan@live.com> - 2.1.6-1
- [Type] other
- [DESC] Initial build of wcdb.